2 # kbuild: Generic definitions
9 space := $(empty) $(empty)
10 space_escape := _-_SPACE_-_
14 # Name of target with a '.' as filename prefix. foo/bar.o => foo/.bar.o
15 dot-target = $(dir $@).$(notdir $@)
18 # The temporary file to save gcc -MD generated dependencies must not
20 depfile = $(subst $(comma),_,$(dot-target).d)
23 # filename of target with directory and extension stripped
24 basetarget = $(basename $(notdir $@))
27 # filename of first prerequisite with directory and extension stripped
28 baseprereq = $(basename $(notdir $<))
31 # Escape single quote for use in echo statements
32 escsq = $(subst $(squote),'\$(squote)',$1)
35 # Easy method for doing a status message
39 kecho := $($(quiet)kecho)
42 # filechk is used to check if the content of a generated file is updated.
44 # define filechk_sample
47 # version.h : Makefile
48 # $(call filechk,sample)
49 # The rule defined shall write to stdout the content of the new file.
50 # The existing file will be compared with the new one.
51 # - If no file exist it is created
52 # - If the content differ the new file is used
53 # - If they are equal no change, and no timestamp update
54 # - stdin is piped in from the first prerequisite ($<) so one has
55 # to specify a valid file as first prerequisite (often the kbuild file)
59 $(filechk_$(1)) < $< > $@.tmp; \
60 if [ -r $@ ] && cmp -s $@ $@.tmp; then \
69 # gcc support functions
70 # See documentation in Documentation/kbuild/makefiles.txt
73 # Usage: CROSS_COMPILE := $(call cc-cross-prefix, m68k-linux-gnu- m68k-linux-)
74 # Return first prefix where a prefix$(CC) is found in PATH.
75 # If no $(CC) found in PATH with listed prefixes return nothing
77 $(word 1, $(foreach c,$(1), \
79 if (which $(strip $(c))$(CC)) > /dev/null 2>&1 ; then \
83 # output directory for tests below
84 TMPOUT := $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/)
87 # Usage: option = $(call try-run, $(CC)...-o "$$TMP",option-ok,otherwise)
88 # Exit code chooses option. "$$TMP" is can be used as temporary file and
89 # is automatically cleaned up.
90 # modifed for U-Boot: prevent cc-option from leaving .*.su files
91 try-run = $(shell set -e; \
92 TMP="$(TMPOUT).$$$$.tmp"; \
93 TMPO="$(TMPOUT).$$$$.o"; \
94 TMPSU="$(TMPOUT).$$$$.su"; \
95 if ($(1)) >/dev/null 2>&1; \
99 rm -f "$$TMP" "$$TMPO" "$$TMPSU")
102 # Usage: cflags-y += $(call as-option,-Wa$(comma)-isa=foo,)
104 as-option = $(call try-run,\
105 $(CC) $(KBUILD_CFLAGS) $(1) -c -x assembler /dev/null -o "$$TMP",$(1),$(2))
108 # Usage: cflags-y += $(call as-instr,instr,option1,option2)
110 as-instr = $(call try-run,\
111 printf "%b\n" "$(1)" | $(CC) $(KBUILD_AFLAGS) -c -x assembler -o "$$TMP" -,$(2),$(3))
114 # Usage: MY_CFLAGS += $(call __cc-option,$(CC),$(MY_CFLAGS),-march=winchip-c6,-march=i586)
115 __cc-option = $(call try-run,\
116 $(1) -Werror $(2) $(3) -c -x c /dev/null -o "$$TMP",$(3),$(4))
119 # Usage: cflags-y += $(call cc-option,-march=winchip-c6,-march=i586)
120 cc-option = $(call __cc-option, $(CC),\
121 $(KBUILD_CPPFLAGS) $(KBUILD_CFLAGS),$(1),$(2))
124 # Usage: cflags-y += $(call hostcc-option,-march=winchip-c6,-march=i586)
125 hostcc-option = $(call __cc-option, $(HOSTCC),\
126 $(HOSTCFLAGS) $(HOST_EXTRACFLAGS),$(1),$(2))
129 # Usage: flag := $(call cc-option-yn,-march=winchip-c6)
130 cc-option-yn = $(call try-run,\
131 $(CC) -Werror $(KBUILD_CPPFLAGS) $(KBUILD_CFLAGS) $(1) -c -x c /dev/null -o "$$TMP",y,n)
134 # Usage: cflags-y += $(call cc-disable-warning,unused-but-set-variable)
135 cc-disable-warning = $(call try-run,\
136 $(CC) -Werror $(KBUILD_CPPFLAGS) $(KBUILD_CFLAGS) -W$(strip $(1)) -c -x c /dev/null -o "$$TMP",-Wno-$(strip $(1)))
139 # Expands to either gcc or clang
140 cc-name = $(shell $(CC) -v 2>&1 | grep -q "clang version" && echo clang || echo gcc)
143 cc-version = $(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-version.sh $(CC))
146 cc-fullversion = $(shell $(CONFIG_SHELL) \
147 $(srctree)/scripts/gcc-version.sh -p $(CC))
150 # Usage: EXTRA_CFLAGS += $(call cc-ifversion, -lt, 0402, -O1)
151 cc-ifversion = $(shell [ $(cc-version) $(1) $(2) ] && echo $(3) || echo $(4))
154 binutils-version = $(shell $(CONFIG_SHELL) $(srctree)/scripts/binutils-version.sh $(AS))
157 # Usage: ldflags += $(call cc-ldoption, -Wl$(comma)--hash-style=both)
158 cc-ldoption = $(call try-run,\
159 $(CC) $(1) $(KBUILD_CPPFLAGS) $(CC_OPTION_CFLAGS) -nostdlib -x c /dev/null -o "$$TMP",$(1),$(2))
162 # Usage: KBUILD_LDFLAGS += $(call ld-option, -X, -Y)
163 ld-option = $(call try-run, $(LD) $(KBUILD_LDFLAGS) $(1) -v,$(1),$(2),$(3))
166 # Usage: KBUILD_ARFLAGS := $(call ar-option,D)
167 # Important: no spaces around options
168 ar-option = $(call try-run, $(AR) rc$(1) "$$TMP",$(1),$(2))
171 # Note this is mainly for HJ Lu's 3 number binutil versions
172 ld-version = $(shell $(LD) --version | $(srctree)/scripts/ld-version.sh)
175 # Usage: $(call ld-ifversion, -ge, 22252, y)
176 ld-ifversion = $(shell [ $(ld-version) $(1) $(2) ] && echo $(3) || echo $(4))
181 # Shorthand for $(Q)$(MAKE) -f scripts/Makefile.build obj=
183 # $(Q)$(MAKE) $(build)=dir
184 build := -f $(srctree)/scripts/Makefile.build obj
187 # Shorthand for $(Q)$(MAKE) -f scripts/Makefile.modbuiltin obj=
189 # $(Q)$(MAKE) $(modbuiltin)=dir
190 modbuiltin := -f $(srctree)/scripts/Makefile.modbuiltin obj
193 # Shorthand for $(Q)$(MAKE) -f scripts/Makefile.dtbinst obj=
195 # $(Q)$(MAKE) $(dtbinst)=dir
196 dtbinst := -f $(if $(KBUILD_SRC),$(srctree)/)scripts/Makefile.dtbinst obj
199 # Shorthand for $(Q)$(MAKE) -f scripts/Makefile.clean obj=
201 # $(Q)$(MAKE) $(clean)=dir
202 clean := -f $(srctree)/scripts/Makefile.clean obj
205 # Shorthand for $(Q)$(MAKE) -f scripts/Makefile.headersinst obj=
207 # $(Q)$(MAKE) $(hdr-inst)=dir
208 hdr-inst := -f $(srctree)/scripts/Makefile.headersinst obj
210 # Prefix -I with $(srctree) if it is not an absolute path.
211 # skip if -I has no parameter
212 addtree = $(if $(patsubst -I%,%,$(1)), \
213 $(if $(filter-out -I/% -I./% -I../%,$(1)),$(patsubst -I%,-I$(srctree)/%,$(1)),$(1)),$(1))
215 # Find all -I options and call addtree
216 flags = $(foreach o,$($(1)),$(if $(filter -I%,$(o)),$(call addtree,$(o)),$(o)))
219 # Short version is used, if $(quiet) equals `quiet_', otherwise full one.
220 echo-cmd = $(if $($(quiet)cmd_$(1)),\
221 echo ' $(call escsq,$($(quiet)cmd_$(1)))$(echo-why)';)
224 cmd = @$(echo-cmd) $(cmd_$(1))
226 # Add $(obj)/ for paths that are not absolute
227 objectify = $(foreach o,$(1),$(if $(filter /%,$(o)),$(o),$(obj)/$(o)))
230 # if_changed - execute command if any prerequisite is newer than
231 # target, or command line has changed
232 # if_changed_dep - as if_changed, but uses fixdep to reveal dependencies
233 # including used config symbols
234 # if_changed_rule - as if_changed but execute rule instead
235 # See Documentation/kbuild/makefiles.txt for more info
237 ifneq ($(KBUILD_NOCMDDEP),1)
238 # Check if both arguments are the same including their order. Result is empty
239 # string if equal. User may override this check using make KBUILD_NOCMDDEP=1
240 arg-check = $(filter-out $(subst $(space),$(space_escape),$(strip $(cmd_$@))), \
241 $(subst $(space),$(space_escape),$(strip $(cmd_$1))))
243 arg-check = $(if $(strip $(cmd_$@)),,1)
246 # Replace >$< with >$$< to preserve $ when reloading the .cmd file
248 # Replace >#< with >$(pound)< to avoid starting a comment in the .cmd file
250 # Replace >'< with >'\''< to be able to enclose the whole string in '...'
251 # (needed for the shell)
252 make-cmd = $(call escsq,$(subst $(pound),$$(pound),$(subst $$,$$$$,$(cmd_$(1)))))
254 # Find any prerequisites that is newer than target or that does not exist.
255 # PHONY targets skipped in both cases.
256 any-prereq = $(filter-out $(PHONY),$?) $(filter-out $(PHONY) $(wildcard $^),$^)
258 # Execute command if command has changed or prerequisite(s) are updated.
260 if_changed = $(if $(strip $(any-prereq) $(arg-check)), \
262 $(echo-cmd) $(cmd_$(1)); \
263 printf '%s\n' 'cmd_$@ := $(make-cmd)' > $(dot-target).cmd, @:)
265 # Execute the command and also postprocess generated .d dependencies file.
266 if_changed_dep = $(if $(strip $(any-prereq) $(arg-check) ), \
268 $(echo-cmd) $(cmd_$(1)); \
269 scripts/basic/fixdep $(depfile) $@ '$(make-cmd)' > $(dot-target).tmp;\
271 mv -f $(dot-target).tmp $(dot-target).cmd, @:)
273 # Usage: $(call if_changed_rule,foo)
274 # Will check if $(cmd_foo) or any of the prerequisites changed,
275 # and if so will execute $(rule_foo).
276 if_changed_rule = $(if $(strip $(any-prereq) $(arg-check) ), \
281 # why - tell why a a target got build
282 # enabled by make V=2
283 # Output (listed in the order they are checked):
284 # (1) - due to target is PHONY
285 # (2) - due to target missing
286 # (3) - due to: file1.h file2.h
287 # (4) - due to command line change
288 # (5) - due to missing .cmd file
289 # (6) - due to target not in $(targets)
290 # (1) PHONY targets are always build
291 # (2) No target, so we better build it
292 # (3) Prerequisite is newer than target
293 # (4) The command line stored in the file named dir/.target.cmd
294 # differed from actual command line. This happens when compiler
296 # (5) No dir/.target.cmd file (used to store command line)
297 # (6) No dir/.target.cmd file and target not listed in $(targets)
298 # This is a good hint that there is a bug in the kbuild file
299 ifeq ($(KBUILD_VERBOSE),2)
301 $(if $(filter $@, $(PHONY)),- due to target is PHONY, \
302 $(if $(wildcard $@), \
303 $(if $(strip $(any-prereq)),- due to: $(any-prereq), \
305 $(if $(cmd_$@),- due to command line change, \
306 $(if $(filter $@, $(targets)), \
307 - due to missing .cmd file, \
308 - due to $(notdir $@) not in $$(targets) \
313 - due to target missing \
317 echo-why = $(call escsq, $(strip $(why)))
320 # delete partially updated (i.e. corrupted) files on error
323 # do not delete intermediate files automatically
326 ifdef CONFIG_SPL_BUILD
328 ifeq ($(CONFIG_TPL_BUILD),y)